## 码流超发
在设备推流过程中，经常会遇到网络带宽波动的现象。当网络上行带宽的下降导致无法满足设备的发送码率时，网络拥塞就不可避免的发生了。此时网络丢包会大量产生，导致接收端音视频卡顿，甚至根本无法播放。

## 如何避免码流超发
为避免网络拥塞，RTSA Lite 会根据网络带宽状况的变化实时给出建议的目标码率值，并以 `on_target_bitrate_changed` 回调给到用户。用户应该根据该回调给出的 `target_bps` 值，实时的调整编码器的输出码率。只要编码器的输出码率不超过目标码率，就避免的拉流超发的情况，也就能够极大的减少网络拥塞带来的音视频体验下降。

## 如何诊断码流超发
码流超发属于一种异常状况。如果你在 SDK 初始化时注册了 on_error 回调（我们强烈建议注册这个回调用以监听任何潜在的异常状况），那么当出现码流超发的状况时，你会收到 on_error 回调，并且其中的 error code为 ERR_SEND_VIDEO_OVER_BANDWIDTH_LIMIT。

一般来说，当用户发送的音视频码流明显超过了设备的上行带宽，音视频帧会被 SDK 缓存起来。当缓存的音视频数据超过一定阈值时，就会触发 ERR_SEND_VIDEO_OVER_BANDWIDTH_LIMIT 错误，与此同时，所有缓存的音视频数据被丢弃。